' Darstellung von 8 Bargraphs als Sinuswelle

DECLARE SUB clrlcd ()
DECLARE SUB cursor (i!)
DECLARE SUB rahmen (x1!, y1!, x2!, y2!)
DECLARE SUB textmodus (modus!, muster!)
DECLARE SUB font (fontnr!, zoomx!, zoomy!)
DECLARE SUB stringout (x!, y!, text$)
DECLARE SUB defbar (barnr!, x1!, y1!, x2!, y2!, aw!, ew!, mst!)
DECLARE SUB bar (barnr!, barwert!)

PRINT "*****************************************************************"
PRINT "*  Darstellung von 16 Bargraphs auf dem Display als Sinuswelle  *"
PRINT "*****************************************************************"

' Zuerst einmal COM2 initialisieren und Ausgabekanal #1 zuweisen
OPEN "COM2:9600,N,8,1,BIN" FOR RANDOM AS #1

CALL clrlcd                              ' Display lschen
CALL cursor(0)                           ' Cursor AUS
CALL rahmen(0, 0, 239, 127)              ' Rechteck zeichnen
CALL font(5, 1, 1)                       ' Zeichensatz 8x16
CALL stringout(60, 1, "BARGRAPH DEMO")   ' berschrift ausgeben

FOR barnr = 1 TO 16                       ' die 16 Bar's definieren
   x = (barnr - 1) * 14 + 9
   CALL defbar(barnr, x, 20, x + 10, 126, 0, 100, 1)
NEXT

PRINT "Abbruch durch Tastendruck"

COM(2) ON
ON COM(2) GOSUB COMhandler:

winkel = 0                               ' 8 Bars als Sinuswelle darstellen
WHILE (INKEY$ = "")
  
   FOR barnr = 1 TO 16
      barwert = 46 * (SIN((winkel + barnr * 15) * 3.14 / 180) + 1) + 8
      CALL bar(17 - barnr, barwert)
   NEXT
   winkel = winkel + 10
   IF (winkel >= 360) THEN
      winkel = 0
   END IF
WEND

COM(2) OFF

CLOSE #1

END

COMhandler:
PRINT ASC(INPUT$(1, 1))
RETURN

SUB bar (barnr, barwert)
    PRINT #1, CHR$(27); "B"; CHR$(barnr); CHR$(barwert)
END SUB

SUB clrlcd
    PRINT #1, CHR$(27); "DL"
END SUB

SUB cursor (i)
    PRINT #1, CHR$(27); "QC"; CHR$(i)
END SUB

SUB defbar (barnr, x1, y1, x2, y2, aw, ew, mst)
    PRINT #1, CHR$(27); "BO"; CHR$(barnr); CHR$(x1); CHR$(y1); CHR$(x2); CHR$(y2); CHR$(aw); CHR$(ew); CHR$(mst)
END SUB

SUB font (fontnr, zoomx, zoomy)
    PRINT #1, CHR$(27); "F"; CHR$(fontnr); CHR$(zoomx); CHR$(zoomy)
END SUB

SUB rahmen (x1, y1, x2, y2)
    PRINT #1, CHR$(27); "RR"; CHR$(x1); CHR$(y1); CHR$(x2); CHR$(y2)
END SUB

SUB stringout (x, y, text$)
    PRINT #1, CHR$(27); "ZL"; CHR$(x); CHR$(y); text$; CHR$(0)
END SUB

SUB textmodus (modus, muster)
    PRINT #1, CHR$(27); "T"; CHR$(richtung); CHR$(modus); CHR$(muster)
END SUB

